package com.emarcotte.glfoo;

/**
 * The ApplicationContext is the core of the graphical portion of GlFoo. It
 * houses the window, opengl driver, opengl/mouse event handler and the
 * app-specific data.
 * 
 * @author Eugene Marcotte <emarcotte@gmail.com>
 */
public interface ApplicationContext {

	/**
	 * Get the GraphicsDriver that GlFoo is using currently.
	 * 
	 * @return The GraphicsDriver that is currently running.
	 */
	public GraphicsDriver getGraphicsDriver();

	/**
	 * Set the GraphicsDriver that GlFoo should use.
	 * 
	 * XXX: This has not been tested at all -- calling thing anywhere after
	 * {@link #run()} may be very bad.
	 * 
	 * @param graphicsDriver
	 */
	public void setGraphicsDriver(GraphicsDriver graphicsDriver);

	public MainWindow getMainWindow();

	public void setMainWindow(MainWindow mainWindow);

	public RenderingContext getCurrentRenderingContext();

	public void setCurrentRenderingContext(RenderingContext newContext);

	public void run();
}
