package com.emarcotte.glfoo;

/**
 * Cameras control the viewing of a scene.
 * 
 * @author Eugene Marcotte <emarcotte@gmail.com>
 */
public interface Camera {

	/**
	 * Apply the perspective to the view.
	 * 
	 * @param driver
	 *            The GraphicsDriver that is currently running.
	 */
	public void applyPerspective(GraphicsDriver driver);

	/**
	 * Apply the position to the view.
	 * 
	 * @param driver
	 *            The GraphicsDriver that is currently running.
	 */
	public void applyPosition(GraphicsDriver driver);
}
