package com.emarcotte.glfoo;

import java.awt.event.KeyListener;

/**
 * The main window. this whole idea probably needs reconsideration since it may
 * be desirable to embed GlFoo into a single swing component for example.
 * 
 * @author Eugene Marcotte <emarcotte@gmail.com>
 */
public interface MainWindow {

	/**
	 * Initialize the main window (create frames, components, etc etc).
	 */
	public void create();

	/**
	 * Start running the main window (make it visible, start OpenGL etc).
	 */
	public void start();

	/**
	 * Kills the main window and OpenGL.
	 */
	public void close();

	/**
	 * Add the new MouseHandler to the main window.
	 * 
	 * @param mouseHandler
	 *            The new MouseHandler.
	 */
	public void addMouseHandler(MouseHandler mouseHandler);

	/**
	 * Add the new KeyListener to the main window.
	 * 
	 * @param keyListener
	 *            The new KeyListener
	 */
	public void addKeyListener(KeyListener keyListener);

	/**
	 * Remove a KeyListener.
	 * 
	 * @param keyListener
	 *            The KeyListener to remove.
	 */
	public void removeKeyListener(KeyListener keyListener);

	/**
	 * Remove a MouseHandler.
	 * 
	 * @param mouseHandler
	 *            The MouseHandler to remove.
	 */
	public void removeMouseHandler(MouseHandler mouseHandler);
}
