package com.emarcotte.glfoo.implementation;

import com.emarcotte.glfoo.ApplicationContext;

public class ApplicationContextProvider {
	private static ApplicationContextProvider instance;
	private ApplicationContext context;

	static {
		instance = new ApplicationContextProvider();
	}

	public static ApplicationContextProvider getInstance() {
		return instance;
	}

	private ApplicationContextProvider() {

	}

	public ApplicationContext getContext() {
		if (context == null) {
			context = new DefaultApplicationContext();

			DefaultGraphicsDriver driver = new DefaultGraphicsDriver();
			DefaultRenderingContext rendering = new DefaultRenderingContext();
			DefaultMainWindow window = new DefaultMainWindow(driver);
			window.create();

			context.setGraphicsDriver(driver);
			context.setCurrentRenderingContext(rendering);
			context.setMainWindow(window);
		}
		return context;
	}
}
