package com.emarcotte.glfoo.implementation;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import com.emarcotte.glfoo.MainWindow;

/**
 * Default KeyListener implementation for GlFoo. It does exactly one thing:
 * 
 * On the keyReleased event for VK_ESCAPE it calls mainWindow.close() with no
 * prompts or anything.
 * 
 * @author Eugene Marcotte <emarcotte@gmail.com>
 */
public class DefaultKeyListener implements KeyListener {

	private MainWindow window;

	public DefaultKeyListener(MainWindow w) {
		window = w;
	}

	public void keyReleased(KeyEvent event) {
		if (event.getKeyCode() == KeyEvent.VK_ESCAPE) {
			window.close();
		}
	}

	public void keyPressed(KeyEvent arg0) {
	}

	public void keyTyped(KeyEvent arg0) {
	}

}
