package com.emarcotte.glfoo.implementation;

import java.awt.Point;
import java.awt.event.MouseEvent;

import javax.swing.SwingUtilities;

import com.emarcotte.glfoo.MouseHandler;

public class DefaultMouseHandler implements MouseHandler {
	private Point mousePoint;

	private DefaultCamera camera;

	public DefaultMouseHandler(DefaultCamera camera) {
		this.camera = camera;
		mousePoint = new Point();
	}

	public void mouseDragged(MouseEvent e) {
		if (SwingUtilities.isRightMouseButton(e)) {
			double z = camera.getZ();
			double diff = e.getY() - mousePoint.getY();
			if (diff != 0) {
				z -= z / diff * .010;
			}
			camera.setZ(z);
		}

		if (SwingUtilities.isLeftMouseButton(e)) {
			camera.addYAngle(e.getX() - mousePoint.getX());
			camera.addXAngle(e.getY() - mousePoint.getY());
		}

		this.mousePoint = e.getPoint();

	}

	public void mouseMoved(MouseEvent e) {
		this.mousePoint = e.getPoint();
	}

	public void mouseClicked(MouseEvent e) {

	}

	public void mouseEntered(MouseEvent e) {

	}

	public void mouseExited(MouseEvent e) {

	}

	public void mousePressed(MouseEvent e) {

	}

	public void mouseReleased(MouseEvent e) {

	}

	public Point getMousePoint() {
		return mousePoint;
	}

	public void setMousePoint(Point mousePoint) {
		this.mousePoint = mousePoint;
	}

}
