package com.emarcotte.glfoo.implementation;

import java.util.LinkedList;
import java.util.List;

import com.emarcotte.glfoo.ApplicationContext;
import com.emarcotte.glfoo.Renderer;
import com.emarcotte.glfoo.RenderingContext;

/**
 * The default implementation of a RenderingContext. GlFoo will put one of these
 * into the {@link ApplicationContext} when it is first created.
 * 
 * @author Eugene Marcotte <emarcotte@gmail.com>
 */
public class DefaultRenderingContext implements RenderingContext {

	/**
	 * The Renderers.
	 */
	private LinkedList<Renderer> renderers;

	/**
	 * Default constructor...
	 */
	public DefaultRenderingContext() {
		renderers = new LinkedList<Renderer>();
	}

	/**
	 * @see RenderingContext#getRenderers()
	 */
	@Override
	public List<Renderer> getRenderers() {
		return renderers;
	}

	/**
	 * Adds a Renderer.
	 * 
	 * @param r
	 *            The new Renderer.
	 */
	public void addRenderer(Renderer r) {
		renderers.add(r);
	}

	@Override
	public void activate() {

	}

	@Override
	public void deactivate() {

	}
}
