package com.emarcotte.glfoo.implementation;

import java.util.LinkedList;
import java.util.List;

import com.emarcotte.glfoo.Renderable;

/**
 * Default implementation of the Selectable interface.
 * 
 * @author Eugene Marcotte
 * 
 */
public final class DefaultSelectable implements Selectable {
	/**
	 * Selectable ID.
	 */
	private int selectableName;
	private Renderable r;
	private LinkedList<SelectableEventHandler> handlers;

	public DefaultSelectable(Renderable r) {
		handlers = new LinkedList<SelectableEventHandler>();
		this.r = r;
	}

	@Override
	public void addEventHandler(SelectableEventHandler seh) {
		handlers.add(seh);
	}

	/**
	 * Get the event handlers for
	 */
	@Override
	public List<SelectableEventHandler> getEventHandlers() {
		return handlers;
	}

	@Override
	public final int getName() {
		return selectableName;
	}

	@Override
	public Renderable getRenderable() {
		return r;
	}

	@Override
	public final void setName(int name) {
		this.selectableName = name;
	}

}
