package com.emarcotte.glfoo.implementation;

import java.util.List;

import com.emarcotte.glfoo.Renderable;

/**
 * Selectable objects are a wrapper Renderable objects. They maintain the
 * relationship between event handlers for some renderable and the renderable
 * itself as well as the 'name' that is assigned by whatever rendering mechanism
 * is being used.
 * 
 * @author Eugene Marcotte
 */
public interface Selectable {
	public void setName(int name);

	public int getName();

	public void addEventHandler(SelectableEventHandler seh);

	public Renderable getRenderable();

	public List<SelectableEventHandler> getEventHandlers();
}
