package com.emarcotte.glfoo.math;

//Vector Class  C version By:Vincent Guingona
//now you can use vectors!
//Java translation: Joe

public class Vector2 {
	private double i;
	private double j;
	
	public Vector2() {
		this(0, 0);
	}
	
	public Vector2(double _i, double _j) {
		i = _i;
		j = _j;
	}
	
	public Vector2(Vector2 vec2) {
		this(vec2.getI(), vec2.getJ());
	}
	
	public void vectorset(double mag, double dir) {
		i = Math.cos(dir) * mag;
		j = Math.sin(dir) * mag;
	}
	
	public Vector2 add(Vector2 vec) {
		Vector2 out = new Vector2(i + vec.getI(),j + vec.getJ());
		return out;
	}
	
	public Vector2 subtract(Vector2 vec) {
		Vector2 out = new Vector2(i - vec.getI(),j - vec.getJ());
		return out;
	}
	
	public double crossProduct(Vector2 cross) {
		return (cross.getI() * j) - (cross.getJ() * i);
	}
	
	public double getI() {
		return i;
	}
	
	public double getJ() {
		return j;
	}
	
	public void setI(double _i) {
		i = _i;
	}
	
	public void setJ(double _j) {
		j = _j;
	}
	
	public double magnitude() {
		return Math.sqrt((i * i) + (j * j));
	}
	
	public double direction() {
		return Math.atan2(j, i);
	}
	
	public Vector2 getUnit() {
		double temp = magnitude();
		Vector2 out = new Vector2(i / temp, j / temp);
		return out;
	}
	
	public void makeUnit() {
		double temp = magnitude();
		i /= temp;
		j /= temp;
	}
	
	public void rotateMe(double angle) {
		vectorset(magnitude(), direction() + angle);
	}
	
}
