package com.emarcotte.glfoo.utils;

import java.awt.Font;
import java.awt.FontFormatException;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class FontManager {
	private static FontManager instance;
	private Map<String, Font> loadedFonts;

	public static FontManager getInstance() {
		if (instance == null) {
			instance = new FontManager();
		}
		return instance;
	}

	private FontManager() {
		loadedFonts = new HashMap<String, Font>();
	}

	public Font getFont(String path, int size) throws FontFormatException,
			IOException {
		Font f = null;
		if (loadedFonts.containsKey(path)) {
			f = loadedFonts.get(path);

		} else {
			f = Font.createFont(Font.TRUETYPE_FONT, ResourceHandler
					.getHandler().getResourceAsStream(path));
		}

		if (f != null) {
			return f.deriveFont(Font.PLAIN, size);
		}
		return null;
	}

}
