package com.emarcotte.glfoo.utils;

import java.nio.IntBuffer;

import javax.media.opengl.GL;
import javax.media.opengl.glu.GLU;

public final class GLUtil {
	private GLUtil() {

	}

	public static boolean checkError(GL gl, GLU glu) {
		int glErr;

		glErr = gl.glGetError();
		if (glErr == GL.GL_NO_ERROR)
			return false;

		while (glErr != GL.GL_NO_ERROR) {
			String sError = glu.gluErrorString(glErr);

			System.out.println(sError);
			glErr = gl.glGetError();
		}
		return true;
	}

	public static final int genBuffer(GL gl) {
		IntBuffer buffer = IntBuffer.allocate(1);
		gl.glGenBuffersARB(1, buffer);
		return buffer.get();
	}

	public static final int[] genBuffers(GL gl, int num) {
		IntBuffer buffer = IntBuffer.allocate(num);
		gl.glGenBuffers(num, buffer);
		return buffer.array();
	}
}
