package com.emarcotte.glfoo.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

/**
 * Handles fetching of resources from jars and files. Like a class loader, but
 * less scary.
 * 
 * @author Eugene Marcotte
 */
public class ResourceHandler {
	private static ResourceHandler handler;

	static {
		handler = new ResourceHandler();
	}

	private ResourceHandler() {

	}

	public static ResourceHandler getHandler() {
		return handler;
	}

	public InputStream getResourceAsStream(String path) {
		URL url = getClass().getClassLoader().getResource(path);
		if (url != null) {
			try {
				return url.openStream();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		try {
			File file = new File(path);
			if (file.exists()) {
				return new FileInputStream(file);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;

	}
}
