package com.emarcotte.glfoo.utils;

import java.io.IOException;
import java.util.HashMap;

import javax.media.opengl.GLException;

import com.sun.opengl.util.texture.Texture;
import com.sun.opengl.util.texture.TextureIO;

public final class TextureManager {
	private static HashMap<String, Texture> textureMap;

	static {
		textureMap = new HashMap<String, Texture>();
	}

	public static final Texture getTexture(String resourcePath,
			boolean mipmaped, String extension) {
		Texture texture = textureMap.get(resourcePath);
		if (texture == null) {
			// try to load
			ResourceHandler handler = ResourceHandler.getHandler();
			try {
				texture = TextureIO
						.newTexture(handler.getResourceAsStream(resourcePath),
								mipmaped, extension);
				textureMap.put(resourcePath, texture);
			} catch (GLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
		return texture;
	}
}
