package com.emarcotte.glfoo.demos;

import javax.media.opengl.GL;

import com.emarcotte.glfoo.ApplicationContext;
import com.emarcotte.glfoo.GraphicsDriver;
import com.emarcotte.glfoo.Renderable;
import com.emarcotte.glfoo.implementation.ApplicationContextProvider;
import com.emarcotte.glfoo.implementation.DefaultRenderingContext;
import com.emarcotte.glfoo.implementation.GraphicRenderer;

public class CubeDemo extends DefaultRenderingContext {

	protected static class Cube implements Renderable {
		double rotation = 0;

		@Override
		public void draw(GraphicsDriver driver) {
			GL gl = driver.getGl();

			gl.glRotated(rotation, .3, 1, 0);
			rotation += 0.1;
			gl.glBegin(GL.GL_QUADS);
			gl.glColor3d(1, .5, .5);
			gl.glVertex3d(1, -1, -1);
			gl.glVertex3d(1, -1, 1);
			gl.glVertex3d(1, 1, 1);
			gl.glVertex3d(1, 1, -1);
			gl.glColor3d(0, .5, .5);
			gl.glVertex3d(-1, -1, -1);
			gl.glVertex3d(-1, -1, 1);
			gl.glVertex3d(-1, 1, 1);
			gl.glVertex3d(-1, 1, -1);
			gl.glColor3d(.5, 1, .5);
			gl.glVertex3d(-1, 1, -1);
			gl.glVertex3d(-1, 1, 1);
			gl.glVertex3d(1, 1, 1);
			gl.glVertex3d(1, 1, -1);
			gl.glColor3d(.5, 0, .5);
			gl.glVertex3d(-1, -1, -1);
			gl.glVertex3d(-1, -1, 1);
			gl.glVertex3d(1, -1, 1);
			gl.glVertex3d(1, -1, -1);
			gl.glColor3d(.5, .5, 1);
			gl.glVertex3d(-1, -1, 1);
			gl.glVertex3d(1, -1, 1);
			gl.glVertex3d(1, 1, 1);
			gl.glVertex3d(-1, 1, 1);
			gl.glColor3d(.5, .5, 0);
			gl.glVertex3d(-1, -1, -1);
			gl.glVertex3d(1, -1, -1);
			gl.glVertex3d(1, 1, -1);
			gl.glVertex3d(-1, 1, -1);
			gl.glEnd();
		}

		@Override
		public void init(GraphicsDriver driver) {

		}

	}

	public CubeDemo() {
		GraphicRenderer gr = new GraphicRenderer();
		gr.addRenderable(new Cube());
		addRenderer(gr);
	}

	public static void main(String[] args) {
		ApplicationContext context = ApplicationContextProvider.getInstance()
				.getContext();
		context.setCurrentRenderingContext(new CubeDemo());
		context.run();
	}

}
