package com.emarcotte.glfoo.implementation;

import junit.framework.Assert;

import org.junit.Test;

import com.emarcotte.glfoo.math.Vector3;

public class FocusableCameraTest {

	@Test
	public void testFocusableCamera() {
		FocusableCamera camera = new FocusableCamera();
		Vector3 focus = camera.getFocus();
		Vector3 position = camera.getPosition();
		Vector3 upVector = camera.getUpVector();

		Assert.assertNotNull(position);
		Assert.assertNotNull(upVector);
		Assert.assertNotNull(focus);
		Assert.assertEquals(camera.getDistance(), 5.0);
		Assert.assertEquals(camera.getFar(), 1000.0);
		Assert.assertEquals(focus.getI(), 0.0);
		Assert.assertEquals(focus.getJ(), 0.0);
		Assert.assertEquals(focus.getK(), 0.0);

		// The next bit is just a sanity check. Since the calculations have not
		// been done yet...
		Assert.assertEquals(position.getI(), 0.0);
		Assert.assertEquals(position.getJ(), 0.0);
		Assert.assertEquals(position.getK(), 0.0);
		Assert.assertEquals(upVector.getI(), 0.0);
		Assert.assertEquals(upVector.getJ(), 0.0);
		Assert.assertEquals(upVector.getK(), 0.0);
		Assert.assertEquals(camera.getPerspective(), 45.0);

		Assert.assertEquals(camera.getXAngle(), 0.0);
		Assert.assertEquals(camera.getYAngle(), 0.0);

	}

	@Test
	public void testSetXAngle() {
		FocusableCamera c = new FocusableCamera();
		Assert.assertEquals(c.getXAngle(), 0.0);
		c.setXAngle(90);
		Assert.assertEquals(c.getXAngle(), Math.toRadians(90.0));
		c.setXAngle(270);
		Assert.assertEquals(c.getXAngle(), Math.toRadians(270.0));
		c.setXAngle(0);
		Assert.assertEquals(c.getXAngle(), Math.toRadians(0.0));
		c.setXAngle(-101);
		Assert.assertEquals(c.getXAngle(), Math.toRadians(-101));
		c.setXAngle(90);
		c.recalculateVectors();
		
	}

	@Test
	public void testSetYAngle() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetFocusDoubleDoubleDouble() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testGetFocus() {
		FocusableCamera camera = new FocusableCamera();
		Vector3 v = camera.getFocus();
		Assert.assertNotNull(v);
	}

	@Test
	public void testGetFocusX() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetFocusX() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testGetFocusY() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetFocusY() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testGetFocusZ() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetFocusZ() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testApplyPerspective() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testApplyPosition() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testAddYAngle() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testAddXAngle() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetFocusVector3() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testGetNear() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetNear() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testGetPerspective() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetPerspective() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testGetFar() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetFar() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testGetDistance() {
		Assert.fail("Not yet implemented");
	}

	@Test
	public void testSetDistance() {
		Assert.fail("Not yet implemented");
	}

}
