package com.emarcotte.glfoo.math;

import org.junit.Test;

import junit.framework.Assert;

public class TestVector3 {

	@Test
	public void TestMultiply() {
		Vector3 v1 = new Vector3(10, 0, 0);
		v1.normalize();
		Assert.assertEquals(v1.getI(), 1.0);
		v1.multiplyMe(10);
		Assert.assertEquals(v1.getI(), 10.0);
	}

	public static void vecCheck(Vector3 v, double x, double y, double z) {
		Assert.assertNotNull(v);
		Assert.assertEquals(x, v.getI());
		Assert.assertEquals(y, v.getJ());
		Assert.assertEquals(z, v.getK());
	}

	@Test
	public void testCopy() {
		Vector3 original = new Vector3();
		vecCheck(original, 0, 0, 0);
		Vector3 newish = new Vector3(1, 12, 30);
		Vector3 newish2 = new Vector3(-1, -30, 1235);
		vecCheck(newish, 1, 12, 30);
		vecCheck(newish2, -1, -30, 1235);
		original.copy(newish);
		vecCheck(original, 1, 12, 30);
		original.copy(newish2);
		vecCheck(original, -1, -30, 1235);
	}
}
