
/* One light for now */
varying vec3 reflectionDirection;

/* Direction from the vertex to the camera */
varying vec3 viewDirection;
varying vec3 lightDirection;
/* The value of the normal . light direction */
varying float NdotL;

void main() {


	/* The vertex position relative to the camera */
	vec3 vertexPosition = vec3(gl_ModelViewMatrix * gl_Vertex);
	
	/* Turn the provided normal into one relative to the view. (Or something?)*/
	vec3 normal = vec3(normalize(gl_NormalMatrix * gl_Normal));
	
	/* Determine the light direction */
	lightDirection = normalize(gl_LightSource[0].position.xyz - vertexPosition);
	
	reflectionDirection = normalize(reflect(-lightDirection, normal));
	
	NdotL = dot(lightDirection, normal);
	
	viewDirection = normalize(-vertexPosition);
	
	gl_Position = ftransform();
}