package com.emarcotte.testrio;

import java.util.List;

public class MD5Animation {
	List<MD5Frame> frames;

	String name;

	int currentFrame;

	double nextFrame;

	double frameRate;

	double lastTime;

	double frameTime;

	public MD5Animation(String name, int frameRate) {
		this.frameRate = frameRate;
		this.name = name;
		frameTime = 4000.0 / (double)frameRate;
		currentFrame = 0;
		lastTime = 0;
	}

	public void setFrames(List<MD5Frame> frames) {
		this.frames = frames;
	}

	public void reset() {
		nextFrame = System.currentTimeMillis() + frameTime;
		lastTime = 0;
		currentFrame = 0;
	}

	public MD5Frame getCurrentFrame() {
		if (System.currentTimeMillis() > nextFrame) {
			lastTime = nextFrame;
			nextFrame = System.currentTimeMillis() + frameTime;
			currentFrame++;
		}

		if (currentFrame >= frames.size() - 1) {
			return null;
		}

		return frames.get(currentFrame);
	}

	public MD5Frame getNextFrame() {
		if (currentFrame >= frames.size() - 1) {
			return null;
		}

		return frames.get(currentFrame + 1);
	}

	public double getFactor() {
		return (double)(System.currentTimeMillis() - lastTime) / frameTime;
	}
}
