package com.emarcotte.testrio;

import java.util.ArrayList;
import java.util.List;

public class MD5Frame {
	private List<MD5Joint> joints;

	public MD5Frame(int numJoints) {
		joints = new ArrayList<MD5Joint>(numJoints);
	}

	public void addJoint(int id, MD5Joint joint) {
		joints.add(joint);
	}

	public MD5Joint getJoint(int i) {
		return joints.get(i);
	}

	public void interpolate(MD5Frame original, MD5Frame next, double factor) {
		for (int i = 0; i < joints.size(); ++i) {
			MD5Joint tj = joints.get(i);
			MD5Joint oj = original.getJoint(i);
			MD5Joint nj = next.getJoint(i);

			tj.interpolate(oj, nj, factor);
		}
	}
}
