package modelview;

import java.io.File;
import java.io.FileFilter;

/**
 * Simple filter for animation files.
 * 
 * @author Eugene Marcotte
 */
public class MD5AnimationFileFilter extends javax.swing.filechooser.FileFilter
		implements FileFilter {
	/**
	 * File extension for animation files.
	 */
	public static final String MD5ANIM_EXTENSION = ".md5anim";

	/**
	 * Rejects files that are not md5 anim files.
	 * 
	 * @param file
	 *            Check this file to see if it is an anim file.
	 * 
	 * @return false if it isn't an anim file, true if it is.
	 */
	public boolean accept(File file) {
		if (file.isDirectory()) {
			return false;
		}
		return file.getName().matches(".*" + MD5ANIM_EXTENSION);
	}

	@Override
	public String getDescription() {
		return "MD5Animation files";
	}
}