package modelview;

import java.io.File;
import java.io.FileFilter;

/**
 * Simple filter for mesh files.
 * 
 * @author Eugene Marcotte
 */
public class MD5MeshFileFilter extends javax.swing.filechooser.FileFilter
		implements FileFilter {
	/**
	 * File extension for mesh files.
	 */
	public static final String MD5MESH_EXTENSION = ".md5mesh";

	/**
	 * Rejects files that are not md5 mesh files.
	 * 
	 * @param file
	 *            Check this file to see if it is an mesh file.
	 * 
	 * @return false if it isn't an mesh file, true if it is.
	 */
	public boolean accept(File file) {
		if (file.isDirectory()) {
			return true;
		}

		return file.getName().matches(".*" + MD5MESH_EXTENSION);
	}

	@Override
	public String getDescription() {
		return "MD5Mesh File";
	}
}