package utils;

import java.awt.image.BufferedImage;

import javax.media.opengl.GL;

/**
 * A texture to be bound within JOGl
 * 
 * @author Kevin Glass
 */
public class Texture {
	private int target;

	private int textureID;

	private int height;

	private int width;

	private BufferedImage image;

	static Texture lastbind = null;

	public Texture(BufferedImage img, int target, int textureID) {
		this.target = target;
		this.textureID = textureID;
		this.image = img;
		height = get2Fold(image.getHeight());
		width = get2Fold(image.getWidth());
	}

	private int get2Fold(int fold) {
		int ret = 2;
		while (ret < fold) {
			ret *= 2;
		}
		return ret;
	}

	public void bind(GL gl) {
		if ((lastbind == null) || (lastbind != this)) {
			gl.glBindTexture(target, textureID);
			lastbind = this;
		}
	}

	public int getHeight() {
		return height;
	}

	public int getWidth() {
		return width;
	}

	public BufferedImage getImage() {
		return image;
	}
}
